import java.util.*;
import java.text.DecimalFormat;
import java.math.RoundingMode;

public class COVID19 {
	private static final DecimalFormat df = new DecimalFormat("0.00");
	public static void main(String[] args) {
		COVID19 obj = new COVID19();
		Scanner sc = new Scanner(System.in);
		
		System.out.println("Covid19 State Data");
		obj.line();
		
		System.out.printf("Enter number of States involved in Covid\t: \t");
		int numStates = sc.nextInt();
		String States[] = new String[numStates];
		int CasesFirst[] = new int[numStates];
		int CasesSecond[] = new int[numStates];
		int totalCases[] = new int[numStates];
		int total = 0;
		int highestCase = totalCases[0];
		String highestState = null;
		
		int RedZone = 0;
		String zone = null;
		
		System.out.printf("enter the name of the states\t\t\t: \t");
		for(int i=0 ; i<numStates ; i++) {
			States[i] = sc.next();
		}
		
		System.out.printf("Enter the "+numStates+" first total cases reading \t\t: \t");
		for(int i=0 ; i<numStates ; i++) {
			CasesFirst[i] = sc.nextInt();
			totalCases[i] = totalCases[i] + CasesFirst[i];
		}
		System.out.printf("Enter the "+numStates+" second total cases reading \t\t: \t");
		for(int i=0 ; i<numStates ; i++) {
			CasesSecond[i] = sc.nextInt();
			totalCases[i] = totalCases[i] + CasesSecond[i];
		}
		
		System.out.println();
		System.out.printf("\t\t\t");
		obj.star();
		System.out.println("\n\n");
		
		for(int i=0 ; i<totalCases.length ; i++) {
			total = total + totalCases[i];
		}
		double AvgCases = total/numStates;
		
		System.out.println("List of states :");
		System.out.println();
		for(int i=0 ; i<totalCases.length ; i++) {
			System.out.printf("%-10s",States[i]);
		}
		System.out.println();
		for(int i=0 ; i<CasesFirst.length ; i++) {
			System.out.printf("%-10s",CasesFirst[i]);
		}
		System.out.println();
		for(int i=0 ; i<CasesSecond.length ; i++) {
			System.out.printf("%-10s",CasesSecond[i]);
		}
		System.out.println();
		for(int i=0 ; i<totalCases.length ; i++) {
			System.out.printf("%-10s",totalCases[i]);
		}
		System.out.println("\n\n");
		System.out.println("Average cases for "+numStates+" states : "+df.format(AvgCases));
		System.out.println("\n");
		
		for(int i=0 ; i<totalCases.length ; i++) {
			if (totalCases[i] >=201) {
				RedZone += 1;
			}
		}
		
		System.out.println("Total red zones today : "+RedZone);
		System.out.println("Final report for today : ");
		System.out.print("\n\n");
		
		System.out.printf("States\t\t"+"Total cases\t"+"Zone");
		System.out.println();
		for(int i=0 ; i<CasesFirst.length ; i++) {
			long totalCharacters = (States[i].chars().filter(ch -> ch !=' ').count());
			System.out.print(States[i]);
			if (totalCharacters > 7) {
				System.out.printf("\t");
				System.out.print(totalCases[i]);
				System.out.printf("\t\t");
				
				if (totalCases[i] < 99) {
					zone = "Green";
				} else if (totalCases[i] >= 100 && totalCases[i] <=200) {
					zone = "Yellow";
				} else {
					zone = "Red";
				}
				if (totalCases[i] > highestCase) {
					highestCase = totalCases[i];
					highestState = States[i];
				}
				System.out.print(zone);
				System.out.println();
			}else {
				System.out.printf("\t\t");
				System.out.print(totalCases[i]);
				System.out.printf("\t\t");
				
				if (totalCases[i] < 99) {
					zone = "Green";
				} else if (totalCases[i] >= 100 && totalCases[i] <=200) {
					zone = "Yellow";
				} else {
					zone = "Red";
				}
				if (totalCases[i] > highestCase) {
					highestCase = totalCases[i];
					highestState = States[i];
				}
				System.out.print(zone);
				System.out.println();
			}
		}
		
		System.out.println();
		System.out.println();
		
		System.out.println("Highest case covid19 today\t: "+highestCase);
		System.out.println("Highest state \t\t\t: "+highestState);
	}
	void star() {
		System.out.println("*******************************************************");
	}
	void line() {
		System.out.println("=====================================");
	}
}
					