#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

typedef struct {
	char category[50];
	int ticket;
	int vip;
	int foodDrink;
	double Amount;
}ticketInf;

char *CategoryCheck (int x, int c) {
	char *Categ;
	if (x == 1) {
		Categ = "Family";
	}	else if (x == 2) {
			if (c > 12) {
				Categ = "Individual-Adult";
			}	else if (c <= 12 && c >= 6) {
				Categ = "Individual-Children";
			}	else if (c < 6 && c >= 2) {
				Categ = "Individual-Toddler";
			}	else if (c <= 1) {
				Categ = "Indiviual-Babies";
			}
	}
	return Categ;
}
void ticketDesc(int t, int x , int a , int b , int c, double* totalAmount, int* ticket) {
	
	double total = 0.00;
	//family amount
	if (x == 1) {
		//vip amount
		if (a == 1) {
			total += (double) 80.00;
			if (b == 1) {
				total += (double) 30.00;
			}	
		//regular amount
		}	else if (a == 2) {
			total += (double) 35.00;
			if (b == 1) {
				total += (double) 30.00;
			}
		}
	//individual amount
	}	else if (x == 2) {
		//age option(adult)
		if (c > 12) {
		//vip option
			if (a == 1) {
				total += (double) 27.00;
				if (b == 1) {
					total += (double) 10.00;
				}
			//regular amount
			}	else if (a == 2) {	
				total += (double) 12.00;
				//food and drink
				if (b == 1) {
					total += (double) 10.00;
				}
			}
		//age option(children)
		}	else if (c <= 12 && c >= 6) {
			//vip option
			if (a == 1) {
				total += (double) 18.00;
				//food and drink
				if (b == 1) {
					total += (double) 8.00;
				}
			}	else if (a == 2) {
				total += (double) 8.00;
				//food and drink
				if (b == 1) {
					total += (double) 8.00;
				}
			}
		//age option(toddler)
		}	else if (c < 6 && c >= 2) {
			if (a == 1) {
			//vip option
				total += (double) 13.00;
				//food and drink
				if (b == 1) {
					total += (double) 5.00;
				}
			}	else if (a == 2) {
				total += (double) 5.00;
				//food and drink
				if (b == 1) {
					total += (double) 5.00;
				}
			}
		//age option(baby)
		}	else if (c <= 1) {
			total += 0.00;
		}
	}
	*totalAmount = total;
	*ticket = 1;
	printf("\nTotal Amount : %.2f\n",total);		
}
int main() {

	char userTerminate;
	char swapFood,swapVip;
	int loop,i,categOpt,vipChoice,ticket,foodChoice,age,numOfTicket;
	int ticketNO = 0;
	double totalAmount = 0.00;
	double grandTotal;
	
	FILE *fptr;
	fptr = fopen("receiptfile.txt", "w");
	if (fptr == NULL) {
		printf("Error occurred when opening file!");
		return 1;
	}
	fprintf(fptr,"=========================================================================================================================\n"
				"||  %-10s    ||       %-15s ||  %-18s ||     %-12s ||    %-12s ||   %-8s ||\n"
				"=========================================================================================================================\n","Receipt NO", "Category" , "Number Of Ticket" , "VIP seat" , "Food&Drink" , "Amount");	
	
	
	printf("\t\t  WELCOME TO MOVIE TICKETING SYSTEM ONLINE\n");
	printf("===================================================================================\n\n\n");
	
	printf("===================================================================================\n");
	printf("||\t\t\t     Movie Ticketing Details\t\t\t         ||\n");
	printf("||--------------------------xx-----------xx------------xx------------------------||\n");
	printf("|| \t   Category \t    || Ticket[RM]||VIP seat[RM]||    Food and Drink[RM]  ||\n");
	printf("||------------xx------------xx-----------xx------------xx------------------------||\n");
	printf("||\t      ||  2 Adults  || 35.00 per ||  45.00 per ||\t\t\t ||\n");
	printf("||   Family   xx------------xx   family  ||   family   ||      30 per family     ||\n");
	printf("||\t      || 2 children ||           ||            ||                        ||\n");
	printf("||------------xx------------xx-----------xx------------xx------------------------||\n");
	printf("||            ||            ||           ||            ||\t\t\t ||\n");
	printf("||            ||    Adult   || 12.00 per ||  15.00 per ||           10           ||\n");
	printf("||            ||            ||   person  ||   person   ||         per pax        ||\n");
	printf("||            ||            ||           ||            ||\t\t\t ||\n");
	printf("||            xx------------xx-----------xx------------xx------------------------||\n");
	printf("||            ||            ||           ||            ||\t\t\t ||\n");
	printf("||            ||  Children  ||           ||            ||\t\t\t ||\n");
	printf("||            ||  (aged 6-) ||  8.00 per ||  10.00 per ||            8           ||\n");
	printf("||            ||  12 years  ||   person  ||   person   ||         per pax        ||\n");
	printf("||            ||    old)    ||           ||            ||\t\t\t ||\n");
	printf("||            ||            ||           ||            ||\t\t\t ||\n");
	printf("|| Individual xx------------xx-----------xx------------xx------------------------||\n");
	printf("||            ||            ||           ||            ||\t\t\t ||\n");
	printf("||   	      ||   Toddler  ||	         ||            ||\t\t\t ||\n");
	printf("||            ||  (aged 2-) ||  5.00 per ||  8.00 per  ||            5           ||\n");
	printf("||            ||   5 years) ||   person  ||   person   ||         per pax        ||\n");
	printf("||            ||    old)    ||           ||            ||\t\t\t ||\n");
	printf("||            ||            ||           ||            ||\t\t\t ||\n");
	printf("||            xx------------xx-----------xx------------xx------------------------||\n");
	printf("||            ||            ||           ||            ||\t\t\t ||\n");
	printf("||   	      ||   Babies   ||	         ||            ||\t\t\t ||\n");
	printf("||            ||  (aged 1-) ||    FREE   ||    FREE    ||            -           ||\n");
	printf("||            || and below) ||           ||            ||\t\t\t ||\n");
	printf("||            ||            ||           ||            ||\t\t\t ||\n");
	printf("||============xx============xx===========xx============xx========================||\n");
	
	printf("\n");
	
	do {
		ticketNO += 1;
		printf("Please enter number of ticket you would like to purchase : ");
		scanf("%d",&numOfTicket);
		
		
		while(numOfTicket > 5 || numOfTicket <= 0) {
			printf("Number of ticket cannot be over 5 or less than 0! Please enter the correct value! : ");
			scanf("%d",&numOfTicket);
		}
		
		fptr = fopen("receiptfile.txt","a");
		if (fptr == NULL) {
			printf("Error occurred when opening file!");
			return 1;
		}
		fprintf(fptr,"||     00%-5d    ",ticketNO);
		
		ticketInf ticketInfo[numOfTicket];
		
		for (i = 0; i < numOfTicket ; i++) {
			printf("Receipt No : 00%d\n",ticketNO);
			printf("Ticket %d/5\n",i+1);
			printf("Please choose your category : \n");
			printf("1 : Family\n");
			printf("2 : Individual\n");
			scanf("%d",&categOpt);
			
			while (!(categOpt == 1 || categOpt == 2)) {
				printf("Invalid Option! Please enter the valid choice : ");
				scanf("%d",&categOpt);
			}
			
			if (categOpt == 1) {
				printf("FAMILY CATEGORY\n");
				printf("=================\n");
				
				printf("Please choose whether you want a VIP room or Regular Room : \n");
				printf("1 : VIP ROOM\n");
				printf("2 : REGULAR ROOM\n");
				scanf("%d",&vipChoice);
				
				while (!(vipChoice == 1 || vipChoice == 2)) {
					printf("Invalid Option! Please enter the valid choice : ");
					scanf("%d",&vipChoice);
				}
				
				if (vipChoice == 1) {
					printf("You have chosen VIP ROOM!");
					printf("\n=================================\n");
					printf("Please choose whether you want to add-on our Food&Drink for the best price!\n");
					printf("1 : Add-on Food&Drink\n");
					printf("2 : No add-on\n");
					scanf("%d",&foodChoice);
					
					while (!(foodChoice == 1 || foodChoice == 2)) {
						printf("Invalid Choice! Please enter the valid choice : ");
						scanf("%d",&foodChoice);
					}
					
					if (foodChoice == 1) {
						printf("Thank you for choosing our Food&Drink add-on!\n");
					}	else if (foodChoice == 2) {
						printf("No add-on wil be added to your bill\n");
					}
				}	else if (vipChoice == 2) {
					printf("You have chosen REGULAR ROOM!");
					printf("\n=================================\n");
					printf("Please choose whether you want to add-on our Food&Drink for the best price!\n");
					printf("1 : Add-on Food&Drink\n");
					printf("2 : No add-on\n");
					scanf("%d",&foodChoice);
					
					while (!(foodChoice == 1 || foodChoice == 2)) {
						printf("Invalid Choice! Please enter the valid choice : ");
						scanf("%d",&foodChoice);
					}
					
					if (foodChoice == 1) {
						printf("Thank you for choosing our Food&Drink add-on!\n");
					}	else if (foodChoice ==2 ) {
						printf("No add-on will be added to your bill\n");
					}
				}
			}	else if (categOpt == 2) {
				printf("INDIVIDUAL CATEGORY\n");
				printf("=========================\n");
				
				printf("Please enter your age : ");
				scanf("%d",&age);
				
				while (age <= 0) {
					printf("Invalid age! Please enter the right value!");
					scanf("%d",&age);
				}
				
				if (age > 12) {
					printf("You're an Adult!\n");
					printf("\n");
					printf("Please choose whether you want a VIP Room or Regular Room : \n");
					printf("1 : VIP ROOM\n");
					printf("2 : REGULAR ROOM\n");
					scanf("%d",&vipChoice);
					
					while (!(vipChoice == 1 || vipChoice == 2)) {
						printf("Invalid Option! Please enter the valid choice : ");
						scanf("%d",&vipChoice);
					}
					
					if (vipChoice == 1) {
						printf("You have chosen VIP ROOM!\n");
						printf("==============================\n");
						printf("Please choose whether you want to add-on our Food&Drink for the best price!\n");
						printf("1 : Add-on Food&Drink\n");
						printf("2 : No add-on\n");
						scanf("%d",&foodChoice);
						
						while (!(foodChoice == 1 || foodChoice == 2)) {
							printf("Invalid Option! Please enter the valid choice : ");
							scanf("%d",&foodChoice);
						}
						
						if (foodChoice == 1) {
							printf("Thank you for choosing our Food&Drink add-on!\n");
						}	else if (foodChoice == 2) {
							printf("No add-on will be added to your bill\n");
						}
					}	else if (vipChoice == 2) {
						printf("You have chosen REGULAR ROOM!\n");
						printf("=====================================\n");
						printf("Please choose whether you want to add-on to our Food&Drink for the best price!\n");
						printf("1 : Add-on Food&Drink\n");
						printf("2 : No add-on\n");
						scanf("%d",&foodChoice);
						
						while (!(foodChoice == 1 || foodChoice == 2)) {
							printf("Invalid option! Please enter the valid choice : ");
							scanf("%d",&foodChoice);
						}
						
						if (foodChoice == 1) {
							printf("Thank you for choosing our Food&Drink add-on!\n");
						}	else if (foodChoice == 2) {
							printf("No add-on will be added to your bill\n");
						}
					}
				}	else if (age <= 12 && age >= 6) {
					printf("You're a Children!\n");
					printf("\n");
					printf("Please choose whether you want a VIP Room or Regular Room : \n");
					printf("1 : VIP ROOM\n");
					printf("2 : REGULAR ROOM\n");
					scanf("%d",&vipChoice);
					
					while (!(vipChoice == 1 || vipChoice == 2)) {
						printf("Invalid Option! Please enter the valid choice : ");
						scanf("%d",&vipChoice);
					}
					
					if (vipChoice == 1) {
						printf("You have chosen VIP ROOM!\n");
						printf("==============================\n");
						printf("Please choose whether you want to add-on our Food&Drink for the best price!\n");
						printf("1 : Add-on Food&Drink\n");
						printf("2 : No add-on\n");
						scanf("%d",&foodChoice);
						
						while (!(foodChoice == 1 || foodChoice == 2)) {
							printf("Invalid Option! Please enter the valid choice : ");
							scanf("%d",&foodChoice);
						}
						
						if (foodChoice == 1) {
							printf("Thank you for choosing our Food&Drink add-on!\n");
						}	else if (foodChoice == 2) {
							printf("No add-on will be added to your bill\n");
						}
					}	else if (vipChoice == 2) {
						printf("You have chosen REGULAR ROOM!\n");
						printf("=====================================\n");
						printf("Please choose whether you want to add-on to our Food&Drink for the best price!\n");
						printf("1 : Add-on Food&Drink\n");
						printf("2 : No add-on\n");
						scanf("%d",&foodChoice);
						
						while (!(foodChoice == 1 || foodChoice == 2)) {
							printf("Invalid option! Please enter the valid choice : ");
							scanf("%d",&foodChoice);
						}
						
						if (foodChoice == 1) {
							printf("Thank you for choosing our Food&Drink add-on!\n");
						}	else if (foodChoice == 2) {
							printf("No add-on will be added to your bill\n");
						}
					}
				}	else if (age <= 5 && age >= 2) {
					printf("You're a Toddler!\n");
					printf("\n");
					printf("Please choose whether you want a VIP Room or Regular Room : \n");
					printf("1 : VIP ROOM\n");
					printf("2 : REGULAR ROOM\n");
					scanf("%d",&vipChoice);
					
					while (!(vipChoice == 1 || vipChoice == 2)) {
						printf("Invalid Option! Please enter the valid choice : ");
						scanf("%d",&vipChoice);
					}
					
					if (vipChoice == 1) {
						printf("You have chosen VIP ROOM!\n");
						printf("==============================\n");
						printf("Please choose whether you want to add-on our Food&Drink for the best price!\n");
						printf("1 : Add-on Food&Drink\n");
						printf("2 : No add-on\n");
						scanf("%d",&foodChoice);
						
						while (!(foodChoice == 1 || foodChoice == 2)) {
							printf("Invalid Option! Please enter the valid choice : ");
							scanf("%d",&foodChoice);
						}
						
						if (foodChoice == 1) {
							printf("Thank you for choosing our Food&Drink add-on!\n");
						}	else if (foodChoice == 2) {
							printf("No add-on will be added to your bill\n");
						}
					}	else if (vipChoice == 2) {
						printf("You have chosen REGULAR ROOM!\n");
						printf("=====================================\n");
						printf("Please choose whether you want to add-on to our Food&Drink for the best price!\n");
						printf("1 : Add-on Food&Drink\n");
						printf("2 : No add-on\n");
						scanf("%d",&foodChoice);
						
						while (!(foodChoice == 1 || foodChoice == 2)) {
							printf("Invalid option! Please enter the valid choice : ");
							scanf("%d",&foodChoice);
						}
						
						if (foodChoice == 1) {
							printf("Thank you for choosing our Food&Drink add-on!\n");
						}	else if (foodChoice == 2) {
							printf("No add-on will be added to your bill\n");
						}
					}
				}	else if (age <= 1) {
					printf("Baby Detected :)\n");
					printf("\n");
					printf("Regular Ticket and VIP ticket for Baby are FREE!\n");
				}
			} //end of categOpt
			ticketDesc(ticketNO,categOpt,vipChoice,foodChoice,age,&totalAmount,&ticket);
			grandTotal += totalAmount;
			
			
			strcpy(ticketInfo[i].category,CategoryCheck(categOpt,age));
			ticketInfo[i].ticket = ticket;
			ticketInfo[i].vip = vipChoice;
			ticketInfo[i].foodDrink = foodChoice;
			ticketInfo[i].Amount = totalAmount;
			
			if (ticketInfo[i].vip == 2) {
				swapVip ='-';
			}	else if (ticketInfo[i].vip == 1) {
				swapVip = ticketInfo[i].vip+'0';
			}
			
			if (ticketInfo[i].foodDrink == 2) {
				swapFood = '-';
			}	else if (ticketInfo[i].foodDrink == 1) {
				swapFood = ticketInfo[i].foodDrink+'0';
			}
			
			if (i == 0) {
				fprintf(fptr,"|| %-19s   ||         %-11d ||        %-9c ||        %-8c ||   %-8.2f ||\n",ticketInfo[i].category,ticketInfo[i].ticket,swapVip,swapFood,ticketInfo[i].Amount);
			}	else {
				fprintf(fptr,"||       %-5s    || %-19s   ||         %-11d ||        %-9c ||        %-8c ||   %-8.2f ||\n","",ticketInfo[i].category,ticketInfo[i].ticket,swapVip,swapFood,ticketInfo[i].Amount);
			}
		} //end of loop
		
		printf("Enter 1 to stop : ");
		scanf("%d",&loop);
		
		fprintf(fptr,"xx----------------xx-----------------------xx---------------------xx------------------xx-----------------xx------------xx\n");
		
	}while (!(loop == 1));
	
	fprintf(fptr,"||  %-10s    ||       %-15s ||  %-18s ||     %-12s ||      %-10s ||   %-8.2f ||\n"
				 "xx----------------xx-----------------------xx---------------------xx------------------xx-----------------xx------------xx\n","","","","","Total",grandTotal);
	
}
